import { Ref } from 'vue';
import { ExportValueOptions, FormBuilderProps, FormSchema } from './FormBuilder.interface';
import { IFormWidget } from './widgets/FormWidget';
declare const _default: import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToOption<FormBuilderProps>, {
    view: boolean;
    saveExpiry: number;
    autoSave: boolean;
    saveDelay: number;
}>, {
    formValue: Ref<any>;
    exportValue: (options?: ExportValueOptions) => Promise<any>;
    regWidget: (path: string, widget: IFormWidget<any>) => void;
    unRegWidget: (path: string, widget: IFormWidget<any>) => void;
    getWidgets: (path?: string | (string | number)[]) => IFormWidget<any>[];
    getValue: (path?: string | (string | number)[]) => any;
    setValue: (path: string | (string | number)[], value: any) => void;
    setValueByFn: (fn: (value: Ref<any>) => void) => void;
    getSchema: (path?: string | (string | number)[]) => FormSchema;
    getView: () => boolean;
    validate: (option?: {
        scrollToInvalidWidget?: boolean;
    }) => import("./FormBuilder.interface").ValidatedMeta[];
    undoValidate: (path?: string | (string | number)[]) => void;
    save: () => Promise<void>;
    load: () => Promise<void>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    change: (value: any) => void;
    "update:value": (value: any) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToOption<FormBuilderProps>, {
    view: boolean;
    saveExpiry: number;
    autoSave: boolean;
    saveDelay: number;
}>>> & {
    onChange?: (value: any) => any;
    "onUpdate:value"?: (value: any) => any;
}, {
    view: boolean;
    saveExpiry: number;
    saveDelay: number;
    autoSave: boolean;
}, {}>;
export default _default;

type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToOption<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
